MARTe2-core - User story #113

MARTe-EX-F-1.2.11: A framework developer shall be capable of putting the executing thread to sleep
for a specified amount of time.

29.05.2015 14:18 - André Neto

Status: Closed Start date:
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 2.00 hours
Target version: 0.2 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Implement requirement MARTe-EX-F-1.2.11 based on the original MARTe implementation

Note: While waiting for a given event or resource to be available a framework developer might decide to wait and return the control to
the operating system schedule.

Source code files modified

e Source\Core\LOPortability\Architecture\x86_cl\HighResolutionTimerA.h
Source\Core\LOPortability\Architecture\x86_gcc\HighResolutionTimerA.h
Source\Core\LOPortability\HighResolutionTimer.cpp
Source\Core\LOPortability\HighResolutionTimer.h
Source\Core\LOPortability\OperatingSystem\Linux\HighResolutionTimerCalibratorOS.h
Source\Core\LOPortability\OperatingSystem\Linux\SleepOS.h
Source\Core\LOPortability\OperatingSystem\Windows\HighResolutionTimerCalibratorOS.h
Source\Core\LOPortability\OperatingSystem\Windows\SleepOS.h
Source\Core\LOPortability\Sleep.cpp

Source\Core\LOPortability\Sleep.h

Architecture & design review
Date of the review: 08/06/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is implemented in a support
class and does not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review
Date of the review: 17/06/2015

Person who did the review: lvan Herrero

Result of review: SUCCESS

List of non-conformities: N/A

Technical debt:

Manual review for Source\Core\LOPortability\Architecture\x86_cl\HighResolutionTimerA.h
This file has not been reviewed, because it is pending further discussion.
Manual review for Source\Core\LOPortability\Architecture\x86_gcc\HighResolutionTimerA.h
This file has not been reviewed, because it is pending further discussion.

Manual review for Source\Core\LOPortability\OperatingSystem\Linux\HighResolutionTimerCalibratorOS.h
This file has not been reviewed, because it is pending further discussion.

Manual review for Source\Core\LOPortability\OperatingSystem\Windows\HighResolutionTimerCalibratorOS.h
This file has not been reviewed, because it is pending further discussion.

Unit test review

Date of the review: 15/07/2015

Person who did the review: lvan Herrero
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities: N/A

Associated revisions

Revision 2b6bf3ab - 12.06.2015 08:50 - Giuseppe Ferro

Implemented sleep methods.
Implemented HighResolutionTimer counter using intrinsics in windows in order to support 64 bit compiler.
#113

Revision f048da13 - 17.06.2015 12:10 - Giuseppe Ferro

Moved THREADS_DEFAULT_STACKSIZE in GeneralDefinitionsOS.h.
Formatted code with new templates.

Fixed errors accordingly with the revision.

#109 #110 #106 #105 #111 #108 #107 #112 #113 #104 #103

Revision 56f896af - 23.06.2015 16:59 - Giuseppe Ferro

Added Threads and ThreadsDatabase tests.
#110 #123 #103 #104 #112 #107 #108 #111 #106 #105 #109 #113

Revision a1ee0477 - 25.06.2015 13:37 - Giuseppe Ferro

Added Threads unit tests.
Renamed previous tests because they are integration tests.
#110 #123 #103 #104 #112 #107 #108 #111 #106 #105 #109 #113

Revision 88afe86d - 09.07.2015 15:37 - Llorenc Capella

#122 ProcessorTypeTest modifications & #113 HighREsolutionTimerTest and
SleepTest

List of changes of #122:  * Test added in ProcessorTypeTest.cpp * Documentation improvements in ProcessorTypeTest.h  * Format
ProcessorTypeTest.cpp, ProcessorTypeTest.h, ProcessorTest.cpp

List of changes #113:  * Name of the sleep functions modified based on the lvan comments.  * Small modifications in
HighResolutionTimer::Counter32.  * TestCounter32 input parameter changed in order to avoid overfloat.

Revision 29729b63 - 10.07.2015 11:21 - Llorenc Capella
US #113 HighResolutionTimerTest modifications

List of changes:  * Tolerance function added in TestPeriodFrequency() * Define the tolerance as a function of the input parameter and lower
limit defined for the tolerance.  * Files formated.

Revision 674604be - 15.07.2015 17:26 - lvan Herrero

#113 - Minor corrections after unit test review

e Some corrections of format on SleepTest and HighResolutionTimerTest.
e SleepTest::SleepTest() deleted because it had an empty implementation.

e SleepTest:: TestSec(float32) and SleepGTest::TestSleepSecF deleted
because target method Sleep::Sec(float32) had been deleted.

¢ HighResolutionTimerTest:: TestPeriodFrequency() mantained but
considered an extra test.

Revision 43614e73 - 15.07.2015 17:28 - lvan Herrero

Merge branch 'develop' into #113-UT-review

History

#1 - 29.05.2015 15:16 - André Neto

- Subject changed from MARTe-EX-F-1.2.11: A framework developer shall be putting a thread to sleep for a specified amount of time. to
MARTe-EX-F-1.2.11: A framework developer shall be capable of putting a thread to sleep for a specified amount of time.

#2 - 03.06.2015 10:56 - Riccardo Vitelli

- Subject changed from MARTe-EX-F-1.2.11: A framework developer shall be capable of putting a thread to sleep for a specified amount of time. to
MARTe-EX-F-1.2.11: A framework developer shall be capable of putting the executing thread to sleep for a specified amount of time.

- Target version changed from Backlog to 0.1
- Start date deleted (29.05.2015)
- Estimated time set to 2.00 h

#3 - 08.06.2015 09:26 - Riccardo Vitelli

- Status changed from New to Arch: Rev

#4 - 08.06.2015 09:27 - Riccardo Vitelli

- Assignee set to André Neto

#5 - 08.06.2015 13:16 - André Neto
- Description updated

#6 - 08.06.2015 17:54 - Riccardo Vitelli
- Status changed from Arch: Rev to Code: Impl

#7 - 08.06.2015 17:54 - Riccardo Vitelli

- Assignee changed from André Neto to Giuseppe Ferro

#8 - 12.06.2015 10:29 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#9 - 12.06.2015 11:16 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#10 - 17.06.2015 11:40 - Ivan Herrero

- Description updated

#11 - 17.06.2015 17:05 - Ivan Herrero

- Description updated

#12 - 18.06.2015 09:48 - Ivan Herrero

- Assignee changed from Ivan Herrero to Giuseppe Ferro

#13 - 18.06.2015 16:36 - lvan Herrero

- Description updated

#14 - 22.06.2015 12:45 - Ivan Herrero
- Status changed from Code: Rev to Code: Impl

#15 - 22.06.2015 17:31 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#16 - 22.06.2015 17:31 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#17 - 23.06.2015 11:41 - lvan Herrero
- Description updated

- Assignee deleted (lvan Herrero)

Code and documentation review passed on revision f7b2aa2. Unit testing implementation pending.

#18 - 23.06.2015 18:03 - André Neto
- Status changed from Code: Rev to Unit: Impl

#19 - 25.06.2015 17:22 - Riccardo Vitelli
- Status changed from Unit: Impl to Unit: Rev

#20 - 01.07.2015 11:27 - lvan Herrero

- Assignee set to Ivan Herrero

#21 - 01.07.2015 15:51 - lvan Herrero

- Description updated

Unit test review made on revision 8b64124 [FAIL].

#22 - 01.07.2015 16:28 - lvan Herrero

- Description updated

#23 - 01.07.2015 17:57 - Riccardo Vitelli

- Assignee deleted (lvan Herrero)

#24 - 01.07.2015 17:59 - Riccardo Vitelli
- Status changed from Unit: Rev to Unit: Impl

#25 - 02.07.2015 18:06 - Riccardo Vitelli

- Target version changed from 0.1 to 0.2

#26 - 09.07.2015 10:04 - Llorenc Capella

- Assignee set to Llorenc Capella

#27 - 14.07.2015 16:48 - Llorenc Capella
- Status changed from Unit: Impl to Unit: Rev

#28 - 14.07.2015 16:52 - Llorenc Capella
- Assignee deleted (Llorenc Capella)

The functions HighResolutionTimerCalibratorOs::GetlnitialTicks & HighResolutionTimerCalibratorOs::GetlnitialTime() are not included in the
HighReolutionTimer.h.

#29 - 15.07.2015 17:42 - lvan Herrero
- Description updated

- Assignee set to Ivan Herrero

A unit test review has been done on revision 6072de0 with a result of "PASS".

Some minor corrections after unit test review committed on revision 674604b.
#30 - 15.07.2015 17:51 - Riccardo Vitelli

- Status changed from Unit: Rev to Closed

#31 - 15.07.2015 17:52 - Riccardo Vitelli

- Assignee deleted (lvan Herrero)
